(in-package  :custom)
(use-package :oli)

(sd-defdialog 'dichte-suchen-dialog
:dialog-title "Dichte suchen"
:toolbox-button t
:variables
  '((bgr   :value-type :assembly
           :modifies nil
           :multiple-items nil
           :prompt-text "Baugruppe angeben."
           :title "Baugruppe"
           :initial-value nil
    )
    ("Suche nach kg/cm^3")
    (dichtu :value-type :number
           :prompt-text "Unteren Wert eingeben."
           :title "Dichte von"
           :initial-value 1
    )
    (dichto :value-type :number
           :prompt-text "Oberen Wert eingeben."
           :title "Dichte bis"
           :initial-value 1
    )
    (teil  :value-type :part
           :modifies nil
           :multiple-items nil
           :prompt-text "Teil, dessen Dichte uebernommen werden soll angeben."
           :title "bern. v. Teil"
           :initial-value nil
           :initial-optional t
           :after-input
           (after-teil-action)
    )
    ("-")
    ("Suchergebnis anzeigen")
    (anzeig :value-type :boolean
            :toggle-type :wide-toggle
            :title "im Darstellungs-Fenster"
            :initial-value t
    )
    (disp   :value-type :boolean
            :toggle-type :wide-toggle
            :title "im Ausgabe-Display"
            :initial-value nil
    )
    (table  :value-type :boolean
            :toggle-type :wide-toggle
            :title "in Tabelle"
            :initial-value nil
    )
    ("-")
    (next  :push-action
           (sd-call-cmds
             (next-action)
           )
           :toggle-type :wide-toggle
           :title "Ausfhren"
    )
   )
:local-functions
  '((after-teil-action ()
     (let ()
      (setf dichtu (sd-inq-part-density teil :realized))
      (setf dichto (sd-inq-part-density teil :realized))
     )
    )
    (next-action ()
     (if anzeig
       (progn
         (remove_from_vp_drawlist (oli::sd-inq-current-vp) :recursive :all_at_top)
         (dc4-suche-dichte-in-bgr bgr dichtu dichto anzeig disp table)
         (fit_vp (oli::sd-inq-current-vp))
       )
       (progn
         (sd-destroy-display-table "Dichte.dtab")
         (custom::dichte-tabelle-erstellen)
         (dc4-suche-dichte-in-bgr bgr dichtu dichto anzeig disp table)
       )
     )
    )
   )
:ok-action
   '(next-action)
)



(defun dc4-suche-dichte-in-bgr (teil_bgr dichtu dichto anzeig disp table)
  (let (teiletyp kind kinder teildicht)
    (setf teiletyp (sel_item-type teil_bgr))
    (if (equal teiletyp *sd-part-seltype*)
      (progn
        (setf teildicht (sd-inq-part-density teil_bgr))
        (when (and (<= dichtu teildicht)
                 (>= dichto teildicht)
             )
          (progn
            (when anzeig
              (progn
                (add_to_vp_drawlist (oli::sd-inq-current-vp) teil_bgr)
              )
            )
            (when disp
              (display (format nil "Dichte ~a fr Teil: --> ~a" teildicht (sd-inq-obj-basename teil_bgr)))
            )
            (when table
              (setf Eintrag (list teildicht (sd-inq-obj-pathname teil_bgr)))
              (sd-insert-logical-table-row "Dichte.ltab" :contents Eintrag)
              (sd-show-display-table "Dichte.dtab" :position '("TOP-MENU-TOOLBOX-TB" :bottomleft 20 20))
            )
          )
        )
      )
      (when (equal teiletyp *sd-assembly-seltype*)
        (progn
          (setf kinder (sd-inq-obj-children teil_bgr))
          (dolist (kind kinder)
            (dc4-suche-dichte-in-bgr kind dichtu dichto anzeig disp table)
          )
        )
      )
    )
  )
)


(defun dichte-tabelle-erstellen ()
 (let ()
  (progn
   (sd-create-logical-table "Dichte.ltab"
    :secured               nil
    :columns               '(:Dichte :Model)
    :columnNames           '("Dichte" "Modellname")
    :types                 '(:number :string)
    :units                 'nil
    :contents              '()
   )
   (sd-create-display-table "Dichte.dtab"
    :tableTitle            "Dichte suchen"
    :logicalTable          "Dichte.ltab"
    :columns               '(:Dichte :Model)
    :applyColumns          '(:Dichte :Model)
    :displayWidth          600
    :displayHeight         300
    :filterStatusLine      nil
    :selectionMode         :single-row
    ;;:applyAction           :default-tokens ;;default
   )
  )
 )
)
